<?php
class WhmCall2
{
	private $callName = '';
	private $url = '';
	public function __construct($callName)
	{
		$this->callName = $callName;
	}
	public function addParam($name, $value)
	{
		if ($this->url != '') {
			$this->url .= '&';
		}
		$this->url .= $name . '=' . urlencode($value);
	}
	public function getCallName()
	{
		return $this->callName;
	}
	public function buildUrl($skey)
	{
		$r = rand();
		$src = $this->callName . $skey . $r;
		$s = md5($src);
		return 'api/?c=whm&a=' . $this->callName . '&r=' . $r . '&s=' . $s;
	}
	public function buildPostData()
	{
		return $this->url;
	}
}
class WhmResult2
{
	public $status = '';
	private $result = array();
	public function add($name, $value)
	{
		$this->result[$name][] = $value;
	}
	public function get($name, $index = 0)
	{
		$value = $this->result[$name];
		return $value[$index];
	}
	public function getAll($name)
	{
		return $this->result[$name];
	}
	public function getCode()
	{
		return intval($this->status);
	}
}
class WhmClient2
{
	public $skey = '';
	public $whm_url = '';
	public $err_msg = '';
	private $result;
	public function setSecurityKey($skey)
	{
		$this->skey = $skey;
	}
	public function setAuth($user, $password)
	{
	}
	public function setUrl($url)
	{
		$this->whm_url = $url;
	}
	public function call(WhmCall2 $call, $tmo = 0)
	{
		$this->result = array();
		$opts = array('http' => array('method' => WHM_CALL_METHOD));
		if (WHM_CALL_METHOD == 'POST') {
			$opts['http']['content'] = $call->buildPostData();
		}
		if (0 < $tmo) {
			$opts['http']['timeout'] = $tmo;
		}
		$url = $this->whm_url . $call->buildUrl($this->skey);
		if (WHM_CALL_METHOD != 'POST') {
			$url .= '&' . $call->buildPostData();
		}
		$msg = @file_get_contents($url, false, stream_context_create($opts));
		if ($msg === FALSE) {
			$this->err_msg = 'cann\'t connect to host';
			return false;
		}
		try {
			$xml = new SimpleXMLElement($msg);
			$result = new WhmResult2();
			foreach ($xml->children() as $child) {
				if ($child->getName() == 'result') {
					$result->status = $child['status'];
					foreach ($child->children() as $node) {
						$result->add($node->getName(), $node[0]);
					}
					break;
				}
			}
			return $result;
		} catch (Exception $e) {
            error_reporting(0);
			echo 'msg=' . $msg . "<br>***********\n";
			return null;
		}
	}
	public function get($name, $index = 0)
	{
		$value = $this->result[$name];
		if (!$value) {
			return false;
		}
		if (count($value) <= $index) {
			return false;
		}
		return $value[$index];
	}
	public function setParam($name, $value)
	{
	}
	public function getLastError()
	{
		return $this->err_msg;
	}
}
define(WHM_CALL_METHOD, 'POST');